//+------------------------------------------------------------------+
//|                                                   EA_GW_2.04.mq4 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Branly"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

enum signal_enum
{
   rsi_signal, 
   trade_signal
};


#define NONE 0
#define DOWN -1
#define UP 1

#define NOTHING 0
#define BUY 1
#define SELL 2

#define BullColor Lime
#define BearColor Red

#define NOSIGNAL  0
#define ABOVEMA   1
#define BELOWMA   2
#define ABOVEBAND 3
#define BELOWBAND 4


#include <TradingRoutines_V1.03a.mqh>
#include <WinUser32.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>
#include <NewsCalendar_V1.02.mqh>
//#include <Strength_Polynome.mqh>

TradingRoutines _trading();

sinput string                 s___Nihilist = "-------      Nihilist Settings      -------";	        // -------------------------------------------------- 
sinput ENUM_TIMEFRAMES           nTF_1 = PERIOD_M5;               // Nihilist TF 1
sinput ENUM_TIMEFRAMES           nTF_2 = PERIOD_M15;              // Nihilist TF 2
sinput ENUM_TIMEFRAMES           nTF_3 = PERIOD_M30;              // Nihilist TF 3
sinput ENUM_TIMEFRAMES           nTF_4 = PERIOD_H1;               // Nihilist TF 4
sinput ENUM_TIMEFRAMES           nTF_5 = PERIOD_H4;               // Nihilist TF 5
sinput ENUM_TIMEFRAMES           nTF_6 = PERIOD_D1;               // Nihilist TF 5

sinput bool                      alertsNiActive             = true;              // Alerts for Nihilist trend detector
sinput double                    niTdUpperLevel             = 92.0;              // Nihilist trend detector upper level
sinput double                    niTdLowerLevel             = -90;               // Nihilist trend detector lower level
sinput int                       alertResetTimeNihilist     = 15;                // Alert reset time Nihilist

sinput string                 s___Ibuko = "-------      Ibuko Settings      -------";	        // -------------------------------------------------- 
sinput ENUM_TIMEFRAMES           iTF_1 = PERIOD_M5;               // Ibuko TF 1
sinput ENUM_TIMEFRAMES           iTF_2 = PERIOD_M15;              // Ibuko TF 2
sinput ENUM_TIMEFRAMES           iTF_3 = PERIOD_H1;               // Ibuko TF 3
sinput ENUM_TIMEFRAMES           iTF_4 = PERIOD_H4;               // Ibuko TF 4
sinput ENUM_TIMEFRAMES           iTF_5 = PERIOD_D1;               // Ibuko TF 5
sinput int                       period_1 = 24;                   // Ibuko PERIOD 1
sinput int                       period_2 = 24;                   // Ibuko PERIOD 2
sinput int                       period_3 = 24;                   // Ibuko PERIOD 3
sinput int                       period_4 = 24;                   // Ibuko PERIOD 4
sinput int                       period_5 = 24;                   // Ibuko PERIOD 5
sinput ENUM_APPLIED_PRICE        price_1 = PRICE_CLOSE;           // Ibuko applied price 1
sinput ENUM_APPLIED_PRICE        price_2 = PRICE_CLOSE;           // Ibuko applied price 2
sinput ENUM_APPLIED_PRICE        price_3 = PRICE_CLOSE;           // Ibuko applied price 3
sinput ENUM_APPLIED_PRICE        price_4 = PRICE_CLOSE;           // Ibuko applied price 4
sinput ENUM_APPLIED_PRICE        price_5 = PRICE_CLOSE;           // Ibuko applied price 5
sinput ENUM_MA_METHOD            method_1 = MODE_EMA;             // Ibuko MA method 1
sinput ENUM_MA_METHOD            method_2 = MODE_EMA;             // Ibuko MA method 2
sinput ENUM_MA_METHOD            method_3 = MODE_EMA;             // Ibuko MA method 3
sinput ENUM_MA_METHOD            method_4 = MODE_EMA;             // Ibuko MA method 4
sinput ENUM_MA_METHOD            method_5 = MODE_EMA;             // Ibuko MA method 5
sinput int                       bufferPips = 20;                 // Ibuko bias in pips

sinput string                 s___Keltner = "-------      Keltner Settings      -------";	        // -------------------------------------------------- 

sinput int                       keltnerPeriod = 50;              // keltner period
sinput double                    atrMultiplier_1 = 2.75;          // keltner atr multiplier 1
sinput double                    atrMultiplier_2 = 3.75;          // keltner atr multiplier 2

sinput string                 s___TDI = "-------      TDI Settings      -------";	        // -------------------------------------------------- 
sinput int                       tdiLookBackBars_tf1 = 264;       // look back bars for scaling tf 1
sinput int                       tdiLookBackBars_tf2 = 224;       // look back bars for scaling tf 2
sinput int                       tdiLookBackBars_tf3 = 110;       // look back bars for scaling tf 3
sinput double                    tdiBias = 9.0;                   // tdi indi bias in percentage
sinput double                    tdiLevel = 85.0;                 // tdi level
sinput string                    tdiIndicatorName = "TDI_mtf+alerts b600+"; // name of tdi indicator
sinput signal_enum               signalType = rsi_signal;         // trade_signal(red), rsi_signal(green)


sinput string                 s___TFs = "-------      TF's for keltner and TDI Settings      -------";	        // -------------------------------------------------- 

sinput ENUM_TIMEFRAMES           tf_1 = PERIOD_H1;                // period 1
sinput ENUM_TIMEFRAMES           tf_2 = PERIOD_H4;                // period 2
sinput ENUM_TIMEFRAMES           tf_3 = PERIOD_D1;                // period 2

sinput int                       alertResetInMinutes = 60;        // Alert reset time in minutes
sinput bool                      alertsActive = false;            // set alerts active
 
sinput string                 s___Alert = "-------      Alert filter Settings      -------";			// --------------------------------------------------
sinput bool                      filterActive = true;             // Set alert filter active
sinput bool                      filterEmailActive = false;       // Emails active
sinput bool                      filterPushActive = false;        // Push notifications active           
sinput bool                      includeNihilist = true;          // Include nihilist trend detector
sinput bool                      includeIbuko = true;             // Include Ibuko
sinput int                       ibukoLevel = 30;                 // ibuko filter level M15, H1, H4, D1
sinput int                       filterAlertResetTime = 30;       // Alert reset time

input string                  s___News	= "-------      News Calendar Settings      -------";			// --------------------------------------------------
int                              NewsCalImpactThreshold = 3;     	// Impact 0=off 1=Low 2=Med 3=High
input int	                     minutesBeforeNews = 30;			   // Minutes before news
input int	                     minutesAfterNews = 15;			   // Minutes after news
sinput int                       newsCalImpactThreshold = 3;     	// Impact 0=off 1=Low 2=Med 3=High
sinput int                       BrokerGMTOffset = 2; 			   // Brokers server offset from GMT
sinput int                       minutesRefresh = 1; 			      // Minutes between Calendar File read
																                  // No need for next 2 inputs if you use defaults
sinput string                    FFcalURL = "http://www.forexfactory.com/ff_calendar_thisweek.xml";   //URL - Forex Factory Calendar
sinput int                       NewsUpdateFreq = 240;		      // Minutes between downloading news

input string                  s___Trade = "-------      Trade Settings      -------";			// --------------------------------------------------

sinput int                       updateFrequency = 2;             // Update frequency in seconds
sinput double                    spreadLevel = 4.0;               // Spread level

sinput int                       magicNumber = 10000;             // Magic number
sinput int                       slippage = 2;                    // Slippage
sinput string                    _volumes = "0.01;0.02;0.03;0.05;0.08;0.10";  // volume button values

input string                  s___Layout = "-------      Layout Settings      -------";			// --------------------------------------------------
sinput int                       xAnchor = 20;                    // x position in pixels
sinput int                       yAnchor = 75;                    // y position in pixels
sinput int                       columnSpacing = 1;               // space between columns in pixelsStreadColumn  
sinput int                       rowHeight = 20;                  // row height in pixels
sinput int                       rowSpacing = 1;                  // space between rows in pixels
sinput int                       fontSize = 7;                    // font size
sinput int                       textIndent = 3;                  // horizontal text indent in pixels
sinput int                       textY_offset = 3;                // vertical text indent in pixels
sinput color                     borderColor = clrGray;           // border color
sinput string                    objectPreamble = "GW_EU_";       // object preamble
sinput int                       offsetPairColumn = 0;            // off set pair column
sinput int                       widthPairColumn = 90;            // width pairs column in pixels
sinput int                       offsetSpreadColumn = 95;         // off set spread column
sinput int                       widthSpreadColumn = 40;          // width spread column in pixels
sinput int                       offsetPipsColumn = 140;          // offset pips done column
sinput int                       widthPipsColumn = 40;            // width PIPS column in pixels
sinput int                       offsetAdrColumn = 185;           // offset ADR column
sinput int                       widthAdrColumn = 40;             // width ADR column in pixels
sinput int                       offsetNihilistColumn = 235;      // offset Nihilist columns
sinput int                       widthNiColumns = 40;             // width Nihilist strength columns in pixels

sinput int                       offsetIbukoColumn = 490;         // offset ibuko columns
sinput int                       widthIbukoEmaColumns = 40;       // width Ibuko/ema column in pixels

sinput int                       offsetTdiColumn_1 = 705;         // offset Tdi TF 1column in pixels
sinput int                       widthTdi_1 = 35;                 // width of Tdi TF1 column in pixels
sinput int                       offsetKeltColumn_1 = 745;        // offset Keltner TF 1column in pixels
sinput int                       widthKelt_1 = 35;                // width of Keltner TF1 column in pixels
sinput int                       offsetTdiColumn_2 = 785;         // offset Tdi TF 1column in pixels
sinput int                       widthTdi_2 = 35;                 // width of Tdi TF1 column in pixels
sinput int                       offsetKeltColumn_2 = 825;        // offset Keltner TF 1column in pixels
sinput int                       widthKelt_2 = 35;                // width of Keltner TF1 column in pixels
sinput int                       offsetTdiColumn_3 = 865;         // offset Tdi TF 1column in pixels
sinput int                       widthTdi_3 = 35;                 // width of Tdi TF1 column in pixels
sinput int                       offsetKeltColumn_3 = 905;        // offset Keltner TF 1column in pixels
sinput int                       widthKelt_3 = 35;                // width of Keltner TF1 column in pixels
sinput int                       offsetTradeButtonsColumn = 950; // offset trade buttons
sinput int                       widthTradeButtons = 30;          // width trade buttons

sinput int                       offsetPair2Column = 1060;        // offset pairnames second time

sinput int                       offsetTradeInfoColumns = 1160;   // offset for actual trades info
sinput int                       widthTradeInfoColumns = 40;      // width trades info columns


NewsCalendar newsCalendar(FFcalURL, NewsUpdateFreq);

string DefaultPairs[] = {     "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD",
                              "CADCHF","CADJPY",
                              "CHFJPY",
                              "EURAUD", "EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURUSD",
                              "GBPAUD","GBPCAD","GBPCHF", "GBPJPY","GBPNZD","GBPUSD",
                              "NZDCAD","NZDCHF","NZDJPY","NZDUSD",
                              "USDCAD","USDCHF","USDJPY"};

int IdDefaultPairs[]    = {   100, 101, 102, 103, 104,
                              200, 201,
                              300,
                              400, 401, 402, 403, 404, 405, 406,
                              500, 501, 502, 503, 504, 505,
                              600, 601, 602, 603,
                              700, 701, 702
                          };

string TradePairs[];

 string     __Level_Settings     = "------------- Level settings ------------";
 bool          useDefaultLevels     = true;             // if true default levels, if false user levels
 double        level_1              = 10.0;             // first level 
 double        level_2              = 20.0;             // second level
 double        level_3              = 30.0;             // third level
 double        level_4              = 40.0;             // fourth level
 double        level_5              = 50.0;             // fifth level
 double        level_6              = 60.0;             // sixth level
 double        level_7              = 70.0;             // seventh level
 double        level_8              = 80.0;             // eighth level
 double        level_9              = 90.0;             // ninth level
 double        level_10             = 100.0;            // tenth level 

static datetime newbar[];
static datetime resetAltAlerts[];
static datetime alertTime[];

int tdiBufferIndex;

double blots[28],slots[28],bprofit[28],sprofit[28],tprofit[28],bpos[28],spos[28];
int totaltrades;
double totalprofit, totallots;
color ProfitColor,ProfitColor1,ProfitColor2,ProfitColor3,PipsColor,Color,Color1,Color2,Color3,Color4,Color5,Color6,Color7,Color8,Color9,Color10,
      Color11,Color12,LotColor,LotColor1,OrdColor,OrdColor1;


struct pair_Info
{

   string _pairName;
   double _multiplier;
   double _point;
   int _digits;
   int _pips;
   
   string   base;
   string   quote;
   
   double adr;
   double adr1;
   double adr5;
   double adr10;
   double adr20;
   
   double Ibuko_MaDash_Value_1;
   double Ibuko_MaDash_Value_2;
   double Ibuko_MaDash_Value_3;
   double Ibuko_MaDash_Value_4;
   double Ibuko_MaDash_Value_5;
   int ibukoState_2;
   int ibukoState_3;
   int ibukoState_4;
   int ibukoState_5;
   
   double tdiValue_1;
   double tdiValue_11;
   double tdiValue_21;
   
   double tdiValue_2;
   double tdiValue_12;
   double tdiValue_22;
   
   double tdiValue_3;
   double tdiValue_13;
   double tdiValue_23;
   
   double keltnerValueUp_11;
   double keltnerValueDown_11;
   double keltnerValueUp_12;
   double keltnerValueDown_12;
   
   double keltnerValueUp_21;
   double keltnerValueDown_21;
   double keltnerValueUp_22;
   double keltnerValueDown_22;
   
   double keltnerValueUp_31;
   double keltnerValueDown_31;
   double keltnerValueUp_32;
   double keltnerValueDown_32;
   
   double   NiTd_M1;
   double   NiTd_M5;
   double   NiTd_M15;
   double   NiTd_M30;
   double   NiTd_H1;
   double   NiTd_H4;
   int      nihilistState;
   bool     AlertNiDone;
   datetime alertNi_Done;
   
   bool disableAlerts;

   bool alertDone;
   datetime alertTime;
   
   bool filterAlertDone;
   datetime filterAlertTime;
   
};

pair_Info pairInfo[];

static datetime trendBarM1;

string tradeVolumes[];
double volumeArray[];
double _lotSize;

int maxVolumesButtons = 5;
int _maxVolumeButtons;

string postfix=StringSubstr(Symbol(),6,6);


int usdIndex = 0;
int eurIndex = 1;
int gbpIndex = 2;
int chfIndex = 3;
int jpyIndex = 4;
int audIndex = 5;
int cadIndex = 6;
int nzdIndex = 7; 

string curr[8] = { "USD", "EUR", "GBP", "CHF", "JPY", "AUD", "CAD", "NZD" };

double arrt[8][3];

int headerOffset_1 = 50;
int headerOffset_2 = 25;
                              
                              
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(updateFrequency);
   
   deleteObjects();
   
   ArrayCopy(TradePairs,DefaultPairs);

   ArrayResize(pairInfo, ArraySize(TradePairs));
   ArrayResize(newbar, ArraySize(TradePairs));
   ArrayResize(resetAltAlerts, ArraySize(TradePairs));
   
   for (int i = 0; i <ArraySize(TradePairs); i++)
   {
      TradePairs[i]=TradePairs[i] + postfix;
      pairInfo[i]._point = MarketInfo(TradePairs[i], MODE_POINT);
      if (pairInfo[i]._point == 0)
      {
         Alert("Missing pair: " + TradePairs[i] + " , for trading");
         return(INIT_FAILED);
      }
      pairInfo[i]._digits = MarketInfo(TradePairs[i], MODE_DIGITS);
      if (pairInfo[i]._digits == 5 || pairInfo[i]._digits == 3 || pairInfo[i]._digits == 1 ) { pairInfo[i]._point *= 10.0;}
      if (pairInfo[i]._digits == 2  ) {pairInfo[i]._point *= 100.0;}
      pairInfo[i]._multiplier = 1.0 / pairInfo[i]._point;
      
      pairInfo[i].base = StringSubstr(TradePairs[i],0,3);
      pairInfo[i].quote = StringSubstr(TradePairs[i],3,3);
   }
   
   // create some buttons for volume selection
   StringSplit(_volumes,';',tradeVolumes);
   _maxVolumeButtons = ArraySize(tradeVolumes);
   if (_maxVolumeButtons > maxVolumesButtons)
   {
      _maxVolumeButtons = maxVolumesButtons;
   }
   ArrayResize(volumeArray, _maxVolumeButtons);
   // show buttons
   SetText(objectPreamble + "VolumeHeader", "Volume selection", 0, xAnchor, ((ArraySize(TradePairs))*(rowHeight + rowSpacing)) + yAnchor + 5, clrYellow, fontSize);
   
   for (int u = 0; u < _maxVolumeButtons; u++)
   {
      volumeArray[u] = StrToDouble(tradeVolumes[u]);
      
      // normalize lotsize
      //volumeArray[u] = _trading.NormalizeLots(Symbol(), volumeArray[u]);
      Create_Button(objectPreamble + "VolumeButton_" + IntegerToString(u), DoubleToStr(volumeArray[u],2), 0,  38, 21, xAnchor + u * 40, (((ArraySize(TradePairs) + 1) * (rowHeight+ rowSpacing))) + yAnchor, 
                     clrBlack, borderColor, clrWhite, fontSize);
      
      if (u == 0)
      {
         ObjectSetInteger(0, objectPreamble + "VolumeButton_0", OBJPROP_BGCOLOR, clrBlue);
         ObjectSetInteger(0, objectPreamble + "VolumeButton_0", OBJPROP_COLOR, clrWhiteSmoke);
         _lotSize = volumeArray[0];
      }
   }
   
   trendBarM1 = 0;
   
   string label;
   
   label = objectPreamble + "_pairHeader";
   SetText(label,"PAIR", 0, xAnchor, yAnchor - headerOffset_1, clrYellow,fontSize);
   label = objectPreamble + "_spreadHeader";
   SetText(label,"Spr.", 0, xAnchor + offsetSpreadColumn, yAnchor - headerOffset_1, clrYellow,fontSize);
   label = objectPreamble + "_pipsHeader";
   SetText(label,"Pips", 0, xAnchor + offsetPipsColumn, yAnchor - headerOffset_1, clrYellow,fontSize);
   label = objectPreamble + "_adrHeader";
   SetText(label,"Adr", 0, xAnchor + offsetAdrColumn, yAnchor - headerOffset_1, clrYellow,fontSize);
   label = objectPreamble + "_niHeader";
   SetText(label,"Nihilist trend detector", 0, xAnchor + offsetNihilistColumn, yAnchor - headerOffset_1, clrYellow,fontSize);
   
   label = objectPreamble + "_niHeader_TF1";
   SetText(label,GetTimeframeString(nTF_1) , 0, xAnchor + offsetNihilistColumn, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_niHeader_TF2";
   SetText(label,GetTimeframeString(nTF_2) , 0, xAnchor + offsetNihilistColumn + 1 * (widthNiColumns+columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_niHeader_TF3";
   SetText(label,GetTimeframeString(nTF_3) , 0, xAnchor + offsetNihilistColumn + 2 * (widthNiColumns+columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_niHeader_TF4";
   SetText(label,GetTimeframeString(nTF_4) , 0, xAnchor + offsetNihilistColumn + 3 * (widthNiColumns+columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_niHeader_TF5";
   SetText(label,GetTimeframeString(nTF_5) , 0, xAnchor + offsetNihilistColumn + 4 * (widthNiColumns+columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_niHeader_TF6";
   SetText(label,GetTimeframeString(nTF_6) , 0, xAnchor + offsetNihilistColumn + 5 * (widthNiColumns+columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);

   label = objectPreamble + "_tdi1_Header";
   SetText(label,"Tdi 1", 0, xAnchor + offsetTdiColumn_1, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_tdi2_Header";
   SetText(label,"Tdi 2", 0, xAnchor + offsetTdiColumn_2, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_tdi3_Header";
   SetText(label,"Tdi 3", 0, xAnchor + offsetTdiColumn_3, yAnchor - headerOffset_2, clrYellow,fontSize);
   
   label = objectPreamble + "_k1_Header";
   SetText(label,"K. 1", 0, xAnchor + offsetKeltColumn_1, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_k2_Header";
   SetText(label,"K. 2", 0, xAnchor + offsetKeltColumn_2, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_k3_Header";
   SetText(label,"K. 3", 0, xAnchor + offsetKeltColumn_3, yAnchor - headerOffset_2, clrYellow,fontSize);
   
   label = objectPreamble + "_ibukoHeader";
   SetText(label,"Ibuko/Ema", 0, xAnchor + offsetIbukoColumn, yAnchor - headerOffset_1, clrYellow,fontSize);
   
   label = objectPreamble + "_ibukoHeader_TF1";
   SetText(label,GetTimeframeString(iTF_1), 0, xAnchor + offsetIbukoColumn, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_ibukoHeader_TF2";
   SetText(label,GetTimeframeString(iTF_2), 0, xAnchor + offsetIbukoColumn + 1 * (widthIbukoEmaColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_ibukoHeader_TF3";
   SetText(label,GetTimeframeString(iTF_3), 0, xAnchor + offsetIbukoColumn + 2 * (widthIbukoEmaColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_ibukoHeader_TF4";
   SetText(label,GetTimeframeString(iTF_4), 0, xAnchor + offsetIbukoColumn + 3 * (widthIbukoEmaColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "_ibukoHeader_TF5";
   SetText(label,GetTimeframeString(iTF_5), 0, xAnchor + offsetIbukoColumn + 4 * (widthIbukoEmaColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   
   label = objectPreamble + "tradeBuyLotsHeader";
   SetText(label,"Buy", 0, xAnchor + offsetTradeInfoColumns, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "tradeSellLotsHeader";
   SetText(label,"Sell", 0, xAnchor + offsetTradeInfoColumns + widthTradeInfoColumns + columnSpacing, yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "tradeBuyMoneyHeader";
   SetText(label,"Buy", 0, xAnchor + offsetTradeInfoColumns + 2 * (widthTradeInfoColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   label = objectPreamble + "tradeSellMoneyHeader";
   SetText(label,"Sell", 0, xAnchor + offsetTradeInfoColumns + 3 * (widthTradeInfoColumns + columnSpacing), yAnchor - headerOffset_2, clrYellow,fontSize);
   
   label = objectPreamble + "tradeTotalsPanelHeader";
   SetPanel(label, 0, xAnchor + offsetTradeInfoColumns, yAnchor - headerOffset_1, 75, 25, clrBlack, clrWhite, 2);
   label = objectPreamble + "tradeTotalsTextHeader";
   SetText(label,"  ", 0, xAnchor + offsetTradeInfoColumns + textIndent, yAnchor - headerOffset_1 + textY_offset, clrYellow, fontSize+1);
   
   
   
   displayPairButtons();
   displaySpread();
   displayPips();
   displayAdr();
   displayNihilist();
   displayIbuko();
   displayTdi_1();
   displayKelt_1();
   displayTdi_2();
   displayKelt_2();
   displayTdi_3();
   displayKelt_3();
   displayPairsEnd();

   displayTradeButtons();
   
   displayTradeInfos();
   
   displayLotsize();
      
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
   // delete all objects
   deleteObjects();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
//---
   calculateSpread();
   calculatePips();
   calculateAdr();
   calculateNihilist();
   if (trendBarM1 != iTime(TradePairs[0], PERIOD_M1, 0))
   {
      trendBarM1 = iTime(TradePairs[0], PERIOD_M1, 0);
      calculateKeltner_1();
      calculateKeltner_2();
      calculateKeltner_3();
      calculateTdi_1();
      calculateTdi_2();
      calculateTdi_3();
      
   }
   calculateIbuko();
   calculateNews();
   
   calculateTradeInfos();
   
   calculateFilter();
   
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
//---
   string strButtonName;   
   if(id == CHARTEVENT_OBJECT_CLICK)
   {
      if (StringFind(sparam,objectPreamble + "Buy_") >= 0)
      {
         for ( int u = 0; u < ArraySize(TradePairs); u++)
         {
            strButtonName = objectPreamble + "Buy_" + IntegerToString(u);
            if (sparam == strButtonName)
            {
               // open buy trade
               _trading.OrderSendReliable(TradePairs[u], OP_BUY, _lotSize, MarketInfo(TradePairs[u], MODE_ASK),
                                             slippage, 0.0, 0.0, magicNumber, "", 0, 0);
               ObjectSetInteger(0, strButtonName, OBJPROP_STATE, 0);
            }
         }
      }
      
      if (StringFind(sparam,objectPreamble + "Sell_") >= 0)
      {
         for ( int u = 0; u < ArraySize(TradePairs); u++)
         {
            strButtonName = objectPreamble + "Sell_" + IntegerToString(u);
            if (sparam == strButtonName)
            {
               // open buy trade
               _trading.OrderSendReliable(TradePairs[u], OP_SELL, _lotSize, MarketInfo(TradePairs[u], MODE_BID),
                                             slippage, 0.0, 0.0, magicNumber, "", 0, 0);
               ObjectSetInteger(0, strButtonName, OBJPROP_STATE, 0);
            }
         }
      }
      
      if (StringFind(sparam,objectPreamble + "Close_") >= 0)
      {
         //Alert(sparam);
         for ( int u = 0; u < ArraySize(TradePairs); u++)
         {
            strButtonName = objectPreamble + "Close_" + IntegerToString(u);
            if (sparam == strButtonName)
            {
               // close trade
               //Alert(strButtonName);
               _trading.closeAllOrders(OP_BUY, TradePairs[u], magicNumber);
               _trading.closeAllOrders(OP_SELL, TradePairs[u], magicNumber);
               ObjectSetInteger(0, strButtonName, OBJPROP_STATE, 0);
            }
         }
      }
      
      if (StringFind(sparam,objectPreamble + "VolumeButton_") >= 0)
      {
         if ( sparam == objectPreamble + "VolumeButton_0")
         {
            for (int u = 0; u < _maxVolumeButtons; u++)
            {
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_BGCOLOR, clrLightGray);
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_COLOR, clrBlack);
            }
            ObjectSetInteger(0, objectPreamble + "VolumeButton_0" , OBJPROP_BGCOLOR, clrBlue);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_0" , OBJPROP_COLOR, clrWhiteSmoke);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_0", OBJPROP_STATE, 0);
            _lotSize = volumeArray[0];
         }
         if ( sparam == objectPreamble + "VolumeButton_1")
         {
            for (int u = 0; u < _maxVolumeButtons; u++)
            {
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_BGCOLOR, clrLightGray);
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_COLOR, clrBlack);
            }
            ObjectSetInteger(0, objectPreamble + "VolumeButton_1" , OBJPROP_BGCOLOR, clrBlue);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_1" , OBJPROP_COLOR, clrWhiteSmoke);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_1", OBJPROP_STATE, 0);
            _lotSize = volumeArray[1];
         }
         if ( sparam == objectPreamble + "VolumeButton_2")
         {
            for (int u = 0; u < _maxVolumeButtons; u++)
            {
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_BGCOLOR, clrLightGray);
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_COLOR, clrBlack);
            }
            ObjectSetInteger(0, objectPreamble + "VolumeButton_2" , OBJPROP_BGCOLOR, clrBlue);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_2" , OBJPROP_COLOR, clrWhiteSmoke);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_2", OBJPROP_STATE, 0);
            _lotSize = volumeArray[2];
         }
         if ( sparam == objectPreamble + "VolumeButton_3")
         {
            for (int u = 0; u < _maxVolumeButtons; u++)
            {
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_BGCOLOR, clrLightGray);
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_COLOR, clrBlack);
            }
            ObjectSetInteger(0, objectPreamble + "VolumeButton_3" , OBJPROP_BGCOLOR, clrBlue);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_3" , OBJPROP_COLOR, clrWhiteSmoke);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_3", OBJPROP_STATE, 0);
            _lotSize = volumeArray[3];
         }
         if ( sparam == objectPreamble + "VolumeButton_4")
         {
            for (int u = 0; u < _maxVolumeButtons; u++)
            {
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_BGCOLOR, clrLightGray);
               ObjectSetInteger(0, objectPreamble + "VolumeButton_" + IntegerToString(u), OBJPROP_COLOR, clrBlack);
            }
            ObjectSetInteger(0, objectPreamble + "VolumeButton_4" , OBJPROP_BGCOLOR, clrBlue);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_4" , OBJPROP_COLOR, clrWhiteSmoke);
            ObjectSetInteger(0, objectPreamble + "VolumeButton_4", OBJPROP_STATE, 0);
            _lotSize = volumeArray[4];
         }
      }
   }
}

//+------------------------------------------------------------------+

void displayPairButtons()
{
   string buttonName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      buttonName = objectPreamble + "Btn_" + IntegerToString(u); 
      Create_Button(buttonName, TradePairs[u], 0, widthPairColumn, rowHeight, xAnchor, yAnchor + u * (rowHeight+rowSpacing),
                        clrBlack, clrWhiteSmoke, borderColor, fontSize);
   }
}

void displaySpread()
{
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "Spr_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetSpreadColumn, yAnchor + u * (rowHeight + rowSpacing), widthSpreadColumn, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Spr_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetSpreadColumn + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void calculateSpread()
{
   string textName;
   double spread;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      textName = objectPreamble + "Spr_Text_" + IntegerToString(u);
      spread = MathAbs(MarketInfo(TradePairs[u], MODE_ASK) - MarketInfo(TradePairs[u],MODE_BID)) * pairInfo[u]._multiplier;
      ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToString(spread,1));
      if (spread < spreadLevel)
      {
         ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
      }
      else
      {
         ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
      }
   }
}

void displayPips()
{
   
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "Pips_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetPipsColumn, yAnchor + u * (rowHeight + rowSpacing), widthPipsColumn, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Pips_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetPipsColumn + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void calculatePips()
{
   string textName;
   for ( int i = 0; i < ArraySize(TradePairs); i++)
   {
      pairInfo[i]._pips = (iClose(TradePairs[i],PERIOD_D1,0)-iOpen(TradePairs[i], PERIOD_D1,0)) * pairInfo[i]._multiplier;     
      textName = objectPreamble + "Pips_Text_" + IntegerToString(i);
      
      ObjectSetString(0, textName, OBJPROP_TEXT, IntegerToString(pairInfo[i]._pips));
      if (pairInfo[i]._pips >= 0)
      {
         ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
      }
      else
      {
         ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
      }
   }
}

void displayAdr()
{
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "Adr_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetAdrColumn, yAnchor + u * (rowHeight + rowSpacing), widthAdrColumn, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Adr_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetAdrColumn + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrYellow, fontSize);
   }
}

void calculateAdr()
{
   double s = 0.0;
   for (int i = 0; i < ArraySize(TradePairs); i++) 
   {
      for(int a = 1; a <= 20; a++) 
      {
         if(pairInfo[i]._multiplier != 0)
            s=s+(iHigh(TradePairs[i],PERIOD_D1,a)-iLow(TradePairs[i],PERIOD_D1, a)) * pairInfo[i]._multiplier;
         if(a==1)
            pairInfo[i].adr1=MathRound(s);
         if(a==5)
            pairInfo[i].adr5=MathRound(s/5);
         if(a==10)
            pairInfo[i].adr10=MathRound(s/10);
         if(a==20)
            pairInfo[i].adr20=MathRound(s/20);
      }
      pairInfo[i].adr = MathRound((pairInfo[i].adr1+pairInfo[i].adr5+pairInfo[i].adr10+pairInfo[i].adr20)/4.0);
      s=0.0;
      
      ObjectSetString(0, objectPreamble + "Adr_Text_" + IntegerToString(i), OBJPROP_TEXT,IntegerToString(pairInfo[i].adr));
   }
}

void displayNihilist()
{
   for ( int i = 0; i < ArraySize(TradePairs); i++)
   {
      // panel objects
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "M1",0, xAnchor + offsetNihilistColumn, 
      (i*(rowHeight + rowSpacing))+ yAnchor, widthNiColumns, rowHeight, clrBlack, borderColor,1);
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "M5",0, xAnchor + offsetNihilistColumn + 1 * (widthNiColumns + columnSpacing), 
      (i*(rowHeight + rowSpacing))+yAnchor, widthNiColumns,rowHeight, clrBlack, borderColor,1);
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "M15",0, xAnchor + offsetNihilistColumn + 2 * (widthNiColumns + columnSpacing), 
      (i*(rowHeight + rowSpacing))+yAnchor, widthNiColumns,rowHeight, clrBlack, borderColor,1);
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "M30",0, xAnchor + offsetNihilistColumn + 3 * (widthNiColumns + columnSpacing), 
      (i*(rowHeight + rowSpacing))+yAnchor, widthNiColumns,rowHeight, clrBlack, borderColor,1);
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "H1",0, xAnchor + offsetNihilistColumn + 4 * (widthNiColumns + columnSpacing), 
      (i*(rowHeight + rowSpacing))+yAnchor, widthNiColumns,rowHeight, clrBlack, borderColor,1);
      SetPanel(objectPreamble + "niTdPanel_" + IntegerToString(i) + "H4",0, xAnchor + offsetNihilistColumn + 5 * (widthNiColumns + columnSpacing), 
      (i*(rowHeight + rowSpacing))+yAnchor, widthNiColumns,rowHeight, clrBlack, borderColor,1);
      
      // text objects
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "M1","0", 0, xAnchor + offsetNihilistColumn + textIndent,
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "M5","0", 0, xAnchor + offsetNihilistColumn + textIndent + 1 * (widthNiColumns + columnSpacing),
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "M15","0", 0, xAnchor + offsetNihilistColumn + textIndent + 2 * (widthNiColumns + columnSpacing),
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "M30","0", 0, xAnchor + offsetNihilistColumn + textIndent + 3 * (widthNiColumns + columnSpacing),
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "H1","0", 0, xAnchor + offsetNihilistColumn + textIndent + 4 * (widthNiColumns + columnSpacing),
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
      SetText(objectPreamble + "niTdText_" + IntegerToString(i) + "H4","0", 0, xAnchor + offsetNihilistColumn + textIndent + 5 * (widthNiColumns + columnSpacing),
      (i*(rowHeight + rowSpacing))+ yAnchor + textY_offset, clrWhiteSmoke, fontSize);
   }

}

void calculateNihilist()
{
   string glbName = "";
   
   // get all global variables
   for ( int u = 0; u < ArraySize(DefaultPairs); u ++)
   {
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_1);
      pairInfo[u].NiTd_M1 = GlobalVariableGet(glbName);
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_2);
      pairInfo[u].NiTd_M5 = GlobalVariableGet(glbName);
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_3);
      pairInfo[u].NiTd_M15 = GlobalVariableGet(glbName);
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_4);
      pairInfo[u].NiTd_M30 = GlobalVariableGet(glbName);
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_5);
      pairInfo[u].NiTd_H1 = GlobalVariableGet(glbName);
      glbName = "NiTd_" + DefaultPairs[u] + "_" + GetTimeframeString(nTF_6);
      pairInfo[u].NiTd_H4 = GlobalVariableGet(glbName);
   }
   
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      if (pairInfo[u].NiTd_M1 >= niTdUpperLevel)
      {
        ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M1,0));
        ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_M1 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M1,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M1,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M1", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      if (pairInfo[u].NiTd_M5 >= niTdUpperLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M5,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_M5 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M5,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M5,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M5", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      if (pairInfo[u].NiTd_M15 >= niTdUpperLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M15,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_M15 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M15,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M15,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M15", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      if (pairInfo[u].NiTd_M30 >= niTdUpperLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M30,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_M30 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M30,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_M30,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "M30", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      if (pairInfo[u].NiTd_H1 >= niTdUpperLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H1,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_H1 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H1,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H1,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H1", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      if (pairInfo[u].NiTd_H4 >= niTdUpperLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H4,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_COLOR, BullColor);
      }
      else if (pairInfo[u].NiTd_H4 <= niTdLowerLevel)
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H4,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_COLOR, BearColor);
      }
      else
      {
         ObjectSetString(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_TEXT, DoubleToStr(pairInfo[u].NiTd_H4,0));
         ObjectSetInteger(0, objectPreamble + "niTdText_" + IntegerToString(u) + "H4", OBJPROP_COLOR, clrWhiteSmoke);
      }
      
      // check for alerts
      if (pairInfo[u].NiTd_M1 >= niTdUpperLevel && pairInfo[u].NiTd_M5 >= niTdUpperLevel && pairInfo[u].NiTd_M15 >= niTdUpperLevel
            && pairInfo[u].NiTd_M30 >= niTdUpperLevel && pairInfo[u].NiTd_H1 >= niTdUpperLevel)
            {
               pairInfo[u].nihilistState = 1;
               if (!pairInfo[u].AlertNiDone && alertsNiActive)
               {
                  Alert("Nihilist trend detector alert for pair: " + TradePairs[u]);
                  pairInfo[u].AlertNiDone = true;
                  pairInfo[u].alertNi_Done = LocalTime();
               }
            }
      else if (pairInfo[u].NiTd_M1 <= niTdLowerLevel && pairInfo[u].NiTd_M5 <= niTdLowerLevel && pairInfo[u].NiTd_M15 <= niTdLowerLevel
            && pairInfo[u].NiTd_M30 <= niTdLowerLevel && pairInfo[u].NiTd_H1 <= niTdLowerLevel)
            {
               pairInfo[u].nihilistState = -1;
               if (!pairInfo[u].AlertNiDone && alertsNiActive)
               {
                  Alert("Trend detector alert for pair: " + TradePairs[u]);
                  pairInfo[u].AlertNiDone = true;
                  pairInfo[u].alertNi_Done = LocalTime();
               }
            }
       else
       {
         pairInfo[u].nihilistState = 0;
       }
       
       if (pairInfo[u].AlertNiDone)
            {
               if (LocalTime() > (pairInfo[u].alertNi_Done + alertResetTimeNihilist * 60))
               {
                  pairInfo[u].AlertNiDone = false;
                  pairInfo[u].alertNi_Done = 0;
                  pairInfo[u].nihilistState = 0;
               }
            }
   }
}

void displayIbuko()
{

   string panelName, textName;
   for (int u = 0; u < 5; u++)
   {
      for (int uu = 0; uu < ArraySize(TradePairs); uu++)
      {
         panelName = objectPreamble + "Ibuko_Panel_" + IntegerToString(u) + "_" + IntegerToString(uu);
         textName = objectPreamble + "Ibuko_Text_" + IntegerToString(u) + "_" + IntegerToString(uu);
         
         SetPanel(panelName, 0, xAnchor + offsetIbukoColumn + u * (widthIbukoEmaColumns + columnSpacing), yAnchor +  uu * (rowHeight + rowSpacing),
                     widthIbukoEmaColumns, rowHeight, clrBlack, borderColor, 1);
         SetText(textName, "", 0, xAnchor + offsetIbukoColumn + u * (widthIbukoEmaColumns + columnSpacing) + textIndent,
                     yAnchor + textY_offset + uu * (rowHeight + rowSpacing), clrWhiteSmoke, fontSize);
      }
   }
}

void calculateIbuko()
{
   string textName;
   double diff;
   
   for (int u = 0; u < 5; u++)
   {
      for (int uu = 0; uu < ArraySize(TradePairs); uu++)
      {

         if (u == 0)
         {
            diff = (iClose(TradePairs[uu], iTF_1, 0) - iMA(TradePairs[uu], iTF_1, period_1, 0, method_1, price_1, 0)) * pairInfo[uu]._multiplier;
            pairInfo[uu].Ibuko_MaDash_Value_1 = MathFloor(diff);
         }
         else if (u == 1)
         {
            diff = (iClose(TradePairs[uu], iTF_2, 0) - iMA(TradePairs[uu], iTF_2, period_2, 0, method_2, price_2, 0)) * pairInfo[uu]._multiplier;
            pairInfo[uu].Ibuko_MaDash_Value_2 = MathFloor(diff);
         }
         else if (u == 2)
         {
            diff = (iClose(TradePairs[uu], iTF_3, 0) - iMA(TradePairs[uu], iTF_3, period_3, 0, method_3, price_3, 0)) * pairInfo[uu]._multiplier;
            pairInfo[uu].Ibuko_MaDash_Value_3 = MathFloor(diff);
         }
         else if (u == 3)
         {
            diff = (iClose(TradePairs[uu], iTF_4, 0) - iMA(TradePairs[uu], iTF_4, period_4, 0, method_4, price_4, 0)) * pairInfo[uu]._multiplier;
            pairInfo[uu].Ibuko_MaDash_Value_4 = MathFloor(diff);
         }
         else if (u == 4)
         {
            diff = (iClose(TradePairs[uu], iTF_5, 0) - iMA(TradePairs[uu], iTF_5, period_5, 0, method_5, price_5, 0)) * pairInfo[uu]._multiplier;
            pairInfo[uu].Ibuko_MaDash_Value_5 = MathFloor(diff);
         }
         else
         {
            diff = 0;
         }
      }
   }
   
   for (int u = 0; u < 5; u++)
   {
      for (int uu = 0; uu < ArraySize(TradePairs); uu++)
      {
         textName = objectPreamble + "Ibuko_Text_" + IntegerToString(u) + "_" + IntegerToString(uu);

            if (u == 0)
            {
               if (pairInfo[uu].Ibuko_MaDash_Value_1 > bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_1,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_1 >= 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_1,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrAqua);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_1 < - bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_1,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_1 < 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_1,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrOrange);
               }
            }
            
            if (u == 1)
            {
               if (pairInfo[uu].Ibuko_MaDash_Value_2 > bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_2,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_2 >= 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_2,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrAqua);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_2 < - bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_2,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_2 < 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_2,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrOrange);
               }
               if (pairInfo[uu].Ibuko_MaDash_Value_2 > ibukoLevel) { pairInfo[uu].ibukoState_2 = 1;}
               else if (pairInfo[uu].Ibuko_MaDash_Value_2 < -ibukoLevel) { pairInfo[uu].ibukoState_2 = -1;}
               else { pairInfo[uu].ibukoState_2 = 0;}
            }
            
            if (u == 2)
            {
               if (pairInfo[uu].Ibuko_MaDash_Value_3 > bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_3,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_3 >= 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_3,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrAqua);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_3 < - bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_3,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_3 < 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_3,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrOrange);
               }
               
               if (pairInfo[uu].Ibuko_MaDash_Value_3 > ibukoLevel) { pairInfo[uu].ibukoState_3 = 1;}
               else if (pairInfo[uu].Ibuko_MaDash_Value_3 < -ibukoLevel) { pairInfo[uu].ibukoState_3 = -1;}
               else { pairInfo[uu].ibukoState_3 = 0;}
            }
            
            if (u == 3)
            {
               if (pairInfo[uu].Ibuko_MaDash_Value_4 > bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_4,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_4 >= 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_4,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrAqua);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_4 < - bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_4,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_4 < 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_4,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrOrange);
               }
               
               if (pairInfo[uu].Ibuko_MaDash_Value_4 > ibukoLevel) { pairInfo[uu].ibukoState_4 = 1;}
               else if (pairInfo[uu].Ibuko_MaDash_Value_4 < -ibukoLevel) { pairInfo[uu].ibukoState_4 = -1;}
               else { pairInfo[uu].ibukoState_4 = 0;}
            }
            
            if (u == 4)
            {
               if (pairInfo[uu].Ibuko_MaDash_Value_5 > bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_5,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrLime);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_5 >= 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_5,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrAqua);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_5 < - bufferPips)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_5,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrRed);
               }
               else if (pairInfo[uu].Ibuko_MaDash_Value_5 < 0)
               {
                  ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToStr(pairInfo[uu].Ibuko_MaDash_Value_5,0));
                  ObjectSetInteger(0, textName,OBJPROP_COLOR, clrOrange);
               }
               
               if (pairInfo[uu].Ibuko_MaDash_Value_5 > ibukoLevel) { pairInfo[uu].ibukoState_5 = 1;}
               else if (pairInfo[uu].Ibuko_MaDash_Value_5 < -ibukoLevel) { pairInfo[uu].ibukoState_5 = -1;}
               else { pairInfo[uu].ibukoState_5 = 0;}
            }
      }
      
   }


}


void displayPairsEnd()
{
   for (int u = 0; u < ArraySize(TradePairs); u++)
   {
      SetPanel(objectPreamble + "newsPairPanel" + IntegerToString(u), 0, xAnchor + offsetPair2Column, yAnchor +  u * (rowHeight + rowSpacing), widthPairColumn, rowHeight,
       clrBlack, borderColor, 1);
      SetText(objectPreamble + "newsPairText" + IntegerToString(u),TradePairs[u], 0, xAnchor + offsetPair2Column + textIndent,  yAnchor +  u * (rowHeight + rowSpacing) + textY_offset, clrBlack, fontSize);
   }
}

void calculateNews()
{
   int tmpLevel;
   string objectname;
   datetime gmt;
   color tmpColor;
   for ( int z = 0; z < 28; z++)
   {
      objectname = objectPreamble + "newsPairText" + IntegerToString(z);
      gmt = LocalTime() - BrokerGMTOffset * 3600;
      
      tmpLevel = newsCalendar.getNewsImpactLevel(TradePairs[z], gmt, minutesBeforeNews, minutesAfterNews);

      if (tmpLevel >= NewsCalImpactThreshold)
      {
         tmpColor = getImpactColor(tmpLevel,clrWhiteSmoke);
      }
      else
      {
         tmpColor = clrDarkGray;
      }
      ObjectSetInteger(0,objectname,OBJPROP_COLOR, tmpColor);
   }
}



void calculateFilter()
{

   string message;
   if (!filterActive) {return;}
   
   for (int u = 0; u < ArraySize(TradePairs); u++)
   {
      if (pairInfo[u].nihilistState == 1 || !includeNihilist)
      {
         if ((pairInfo[u].ibukoState_2 == 1 && pairInfo[u].ibukoState_3 == 1
               && pairInfo[u].ibukoState_4 == 1 && pairInfo[u].ibukoState_5 == 1) || !includeIbuko)
         {
            // set alert
            if (!pairInfo[u].filterAlertDone)
            {
               message = "Filter UP alert for pair: " + TradePairs[u];
               Alert(message);
               pairInfo[u].filterAlertTime = LocalTime();
               pairInfo[u].filterAlertDone = true;
               if (filterEmailActive)
               {
                  SendMail("GW alert", message);
               }
               if (filterPushActive)
               {
                  SendNotification(message);
               }
            }
         }
      }
      else if (pairInfo[u].nihilistState == -1 || !includeNihilist)
      {
         
         if ((pairInfo[u].ibukoState_2 == -1 && pairInfo[u].ibukoState_3 == -1
               && pairInfo[u].ibukoState_4 == -1 && pairInfo[u].ibukoState_5 == -1) || !includeIbuko)
         {
            // set alert
            if (!pairInfo[u].filterAlertDone)
            {
               message = "Filter DOWN alert for pair: " + TradePairs[u];
               Alert(message);
               pairInfo[u].filterAlertTime = LocalTime();
               pairInfo[u].filterAlertDone = true;
               if (filterEmailActive)
               {
                  SendMail("GW alert", message);
               }
               if (filterPushActive)
               {
                  SendNotification(message);
               }
            }
         }
      }
      
      if (pairInfo[u].filterAlertDone)
      {
         if (LocalTime() > pairInfo[u].filterAlertTime + filterAlertResetTime * 60)
         {
            pairInfo[u].filterAlertDone = false;
            pairInfo[u].filterAlertTime = 0;
         }
      }
   }
}


void displayTradeButtons()
{

   for (int u = 0; u < ArraySize(TradePairs); u++)
   {
      Create_Button(objectPreamble + "Buy_" + IntegerToString(u), "B", 0, widthTradeButtons, rowHeight,
                     xAnchor + offsetTradeButtonsColumn, yAnchor + u * (rowHeight + rowSpacing), 
                     clrBlue, clrBlack, borderColor, fontSize);
   
      Create_Button(objectPreamble + "Sell_" + IntegerToString(u), "S", 0, widthTradeButtons, rowHeight,
                     xAnchor + offsetTradeButtonsColumn + widthTradeButtons + textIndent, yAnchor + u * (rowHeight + rowSpacing), 
                     clrOrange, clrBlack, borderColor, fontSize);

      Create_Button(objectPreamble + "Close_" + IntegerToString(u), "C", 0, widthTradeButtons, rowHeight,
                     xAnchor + offsetTradeButtonsColumn + 2*(widthTradeButtons + textIndent), yAnchor + u * (rowHeight + rowSpacing), 
                     clrRed, clrBlack, borderColor, fontSize);
   }

}

void displayLotsize()
{

}

int getIndex( string _symbol)
{
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      if (_symbol == TradePairs[u])
      {
         return u;
      }
   }
   return -1;
}

void Create_Button(string but_name, string label, int window, int xsize, int ysize, 
                     int xdist, int ydist, int bgcolor, int fcolor, int bcolor, int _fontSize)
{
   if(ObjectFind(0,but_name)<0)
   {
      if(!ObjectCreate(0,but_name,OBJ_BUTTON, window,0,0))
        {
         Print(__FUNCTION__,
               ": failed to create the button! Error code = ",GetLastError());
         return;
        }
      ObjectSetString(0,but_name,OBJPROP_TEXT,label);
      ObjectSetInteger(0,but_name,OBJPROP_XSIZE,xsize);
      ObjectSetInteger(0,but_name,OBJPROP_YSIZE,ysize);
      ObjectSetInteger(0,but_name,OBJPROP_CORNER,CORNER_LEFT_UPPER);     
      ObjectSetInteger(0,but_name,OBJPROP_XDISTANCE,xdist);      
      ObjectSetInteger(0,but_name,OBJPROP_YDISTANCE,ydist);         
      ObjectSetInteger(0,but_name,OBJPROP_BGCOLOR,bgcolor);
      ObjectSetInteger(0,but_name,OBJPROP_COLOR,fcolor);
      ObjectSetInteger(0,but_name,OBJPROP_BORDER_COLOR,bcolor);
      ObjectSetInteger(0,but_name,OBJPROP_FONTSIZE,_fontSize);
      ObjectSetInteger(0,but_name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,but_name, OBJPROP_CORNER,5);
      //ObjectSetInteger(0,but_name,OBJPROP_BORDER_COLOR,ChartGetInteger(0,CHART_COLOR_FOREGROUND));
      ObjectSetInteger(0,but_name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      
      ChartRedraw();      
   }
}

//+------------------------------------------------------------------+
void SetText(string name,string text, int window, int x,int y,color colour,int _fontsize=12)
{
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,window,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,_fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_TEXT,text);
}

//+------------------------------------------------------------------+

void SetObjText(long window, string name,string CharToStr,int x,int y,color colour,int _fontsize=12)
{
   if(ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL, window,0,0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,_fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPanel(string name,int sub_window,int x, int y, int width, int height, color bg_color, color border_clr,int border_width)
  {
   if(ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
      ObjectSetInteger(0,name, OBJPROP_CORNER,5);
     }
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
}

color  getHM_Color(int mVal)
{
   if (useDefaultLevels)
   {
      if(mVal >= 0 && mVal <= 10)
            return clrWhite;
      if(mVal > 10 && mVal <= 20)
         return clrLightCyan;
      if(mVal > 20 && mVal <= 30)
         return clrPowderBlue;
      if(mVal > 30 && mVal <= 40)
         return clrPaleTurquoise;
      if(mVal > 40 && mVal <= 50)
         return clrLightBlue;
      if(mVal > 50 && mVal <= 60)
         return clrSkyBlue;
      if(mVal > 60 && mVal <= 70)
         return clrTurquoise;
      if(mVal > 70 && mVal <= 80)
         return clrDeepSkyBlue;
      if(mVal > 80 && mVal <= 90)
         return clrSteelBlue;
      if(mVal > 90 && mVal <= 100)
         return clrBlue;
      if(mVal > 100)
         return clrMediumBlue;

      if(mVal <= 0 && mVal > -10)
         return clrWhite;
      if(mVal <= -10 && mVal > -20)
         return clrSeashell;
      if(mVal <= -20 && mVal > -30)
         return clrMistyRose;
      if(mVal <= -30 && mVal > -40)
         return clrPink;
      if(mVal <= -40 && mVal > -50)
         return clrLightPink;
      if(mVal <= -50 && mVal > -60)
         return clrPlum;
      if(mVal <= -60 && mVal >-70)
         return clrViolet;
      if(mVal <= -70 && mVal > -80)
         return clrOrchid;
      if(mVal <= -80 && mVal > -90)
         return clrDeepPink;
      if(mVal <= -90)
         return clrRed;
   }
   else
   {
      if(mVal >= 0.0 && mVal <= level_1)
            return clrWhite;
      if(mVal > level_1 && mVal <= level_2)
         return clrLightCyan;
      if(mVal > level_2 && mVal <= level_3)
         return clrPowderBlue;
      if(mVal > level_3 && mVal <= level_4)
         return clrPaleTurquoise;
      if(mVal > level_4 && mVal <= level_5)
         return clrLightBlue;
      if(mVal > level_5 && mVal <= level_6)
         return clrSkyBlue;
      if(mVal > level_6 && mVal <= level_7)
         return clrTurquoise;
      if(mVal > level_7 && mVal <= level_8)
         return clrDeepSkyBlue;
      if(mVal > level_8 && mVal <= level_9)
         return clrSteelBlue;
      if(mVal > level_9 && mVal <= level_10)
         return clrBlue;
      if(mVal > level_10)
         return clrMediumBlue;

      if(mVal <= 0.0 && mVal > -level_1)
         return clrWhite;
      if(mVal <= -level_1 && mVal > -level_2)
         return clrSeashell;
      if(mVal <= -level_2 && mVal > -level_3)
         return clrMistyRose;
      if(mVal <= -level_3 && mVal > -level_4)
         return clrPink;
      if(mVal <= -level_4 && mVal > -level_5)
         return clrLightPink;
      if(mVal <= -level_5 && mVal > -level_6)
         return clrPlum;
      if(mVal <= -level_6 && mVal > -level_7)
         return clrViolet;
      if(mVal <= -level_7 && mVal > -level_8)
         return clrOrchid;
      if(mVal <= -level_8 && mVal > -level_9)
         return clrDeepPink;
      if(mVal <= -level_9)
         return clrRed;
   }
   return clrOrange;
 }
 
 color getImpactColor(int value)
{
   if (value == 0) {return clrLime;}
   if (value == 1) {return clrRed;}
   if (value == 2) {return clrOrange;}
   if (value == 3) {return clrPink;}
   return clrLime;
}

color getImpactColor(int value, color _default)
{
   if (value == 0) {return _default;}
   if (value == 3) {return clrRed;}
   if (value == 2) {return clrOrange;}
   if (value == 1) {return clrYellow;}
   return _default;
}


void deleteObjects()
{
   string s;
   string name;
   s = objectPreamble; //_symbolPair;
   //s = Symbol();
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
   }
}

//+------------------------------------------------------------------+
//| GetTimeframeString( int tf )                                     |
//+------------------------------------------------------------------+
string GetTimeframeString( int tf )
{
   string result;
   switch ( tf )
   {
      case PERIOD_M1:   result = "M1";    break;
      case PERIOD_M5:   result = "M5";    break;
      case PERIOD_M15:  result = "M15";   break;
      case PERIOD_M30:  result = "M30";   break;
      case PERIOD_H1:   result = "H1";    break;
      case PERIOD_H4:   result = "H4";    break;
      case PERIOD_D1:   result = "D1";    break;
      case PERIOD_W1:   result = "W1";    break;
      case PERIOD_MN1:  result = "MN1";   break;
      default: result = "SRITSOD";
   }
   return ( result );
}

void displayTdi_1()
{
   
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PTdi1_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTdiColumn_1, yAnchor + u * (rowHeight + rowSpacing), widthTdi_1, rowHeight, clrBlack, borderColor, 1);
      textName = objectPreamble + "Tdi1_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTdiColumn_1 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void displayTdi_2()
{
   
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PTdi2_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTdiColumn_2, yAnchor + u * (rowHeight + rowSpacing), widthTdi_2, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Tdi2_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTdiColumn_2 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void displayTdi_3()
{
   
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PTdi3_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTdiColumn_3, yAnchor + u * (rowHeight + rowSpacing), widthTdi_1, rowHeight, clrBlack, borderColor, 1);
      textName = objectPreamble + "Tdi3_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTdiColumn_3 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void calculateTdi_1()
{
   double maxValue, minValue, resultValue;
   double tmpValue_1, tmpValue_2, tmpValue_3, tmpValue_4, tmpValue_5;
   double minWindow, maxWindow, tmpValue;
   string textName;
   string panelName;
   
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      maxValue = -10000.0;
      minValue = 10000.0;
      
      for ( int uu = 0; uu < tdiLookBackBars_tf1; uu++)
      {
         tmpValue_1 = iCustom(TradePairs[u], tf_1, tdiIndicatorName, 0, uu);
         tmpValue_2 = iCustom(TradePairs[u], tf_1, tdiIndicatorName, 2, uu);
         tmpValue_3 = iCustom(TradePairs[u], tf_1, tdiIndicatorName, 3, uu);
         tmpValue_4 = iCustom(TradePairs[u], tf_1, tdiIndicatorName, 1, uu);
         tmpValue_5 = iCustom(TradePairs[u], tf_1, tdiIndicatorName, 4, uu);
         
         if (tmpValue_1 > maxValue) { maxValue = tmpValue_1;}
         if (tmpValue_2 > maxValue) { maxValue = tmpValue_2;}
         if (tmpValue_3 > maxValue) { maxValue = tmpValue_3;}
         if (tmpValue_4 > maxValue) { maxValue = tmpValue_4;}
         if (tmpValue_5 > maxValue) { maxValue = tmpValue_5;}
         
         if (tmpValue_1 < minValue) { minValue = tmpValue_1;}
         if (tmpValue_2 < minValue) { minValue = tmpValue_2;}
         if (tmpValue_3 < minValue) { minValue = tmpValue_3;}
         if (tmpValue_4 < minValue) { minValue = tmpValue_4;}
         if (tmpValue_5 < minValue) { minValue = tmpValue_5;}
      }
      
      if (TradePairs[u] == "CADJPY")
      {
         //Alert(maxValue);
      }
      
      minWindow = minValue - (maxValue - minValue) * tdiBias * 0.01 / 2;
      maxWindow = maxValue + (maxValue - minValue) * tdiBias * 0.01 / 2;
      resultValue = iCustom(TradePairs[u], tf_1, tdiIndicatorName, tdiBufferIndex, 0);
      if ((maxWindow - minWindow) > 0.0)
      {
         tmpValue = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         tmpValue = 0.01;
      }
      
      resultValue = iCustom(TradePairs[u], tf_1, tdiIndicatorName, tdiBufferIndex, 1);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_11 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_11 = 0.01;
      }
      resultValue = iCustom(TradePairs[u], tf_1, tdiIndicatorName, tdiBufferIndex, 2);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_21 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_21 = 0.01;
      }
      
      textName = objectPreamble + "Tdi1_Text_" + IntegerToString(u);
      panelName = objectPreamble + "PTdi1_Panel_" + IntegerToString(u);
      ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToString(tmpValue, 1));
      
      if (tmpValue >= tdiLevel)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
      }
      else if (tmpValue <= (100 - tdiLevel))
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      pairInfo[u].tdiValue_1 = tmpValue;
   }
}

void calculateTdi_2()
{
   double maxValue, minValue, resultValue;
   double tmpValue_1, tmpValue_2, tmpValue_3, tmpValue_4, tmpValue_5;
   double minWindow, maxWindow, tmpValue;
   string textName;
   string panelName;
   
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      maxValue = -10000.0;
      minValue = 10000.0;
      
      for ( int uu = 0; uu < tdiLookBackBars_tf2; uu++)
      {
         tmpValue_1 = iCustom(TradePairs[u], tf_2, tdiIndicatorName, 0, uu);
         tmpValue_2 = iCustom(TradePairs[u], tf_2, tdiIndicatorName, 2, uu);
         tmpValue_3 = iCustom(TradePairs[u], tf_2, tdiIndicatorName, 3, uu);
         tmpValue_4 = iCustom(TradePairs[u], tf_2, tdiIndicatorName, 1, uu);
         tmpValue_5 = iCustom(TradePairs[u], tf_2, tdiIndicatorName, 4, uu);
         
         if (tmpValue_1 > maxValue) { maxValue = tmpValue_1;}
         if (tmpValue_2 > maxValue) { maxValue = tmpValue_2;}
         if (tmpValue_3 > maxValue) { maxValue = tmpValue_3;}
         if (tmpValue_4 > maxValue) { maxValue = tmpValue_4;}
         if (tmpValue_5 > maxValue) { maxValue = tmpValue_5;}
         
         if (tmpValue_1 < minValue) { minValue = tmpValue_1;}
         if (tmpValue_2 < minValue) { minValue = tmpValue_2;}
         if (tmpValue_3 < minValue) { minValue = tmpValue_3;}
         if (tmpValue_4 < minValue) { minValue = tmpValue_4;}
         if (tmpValue_5 < minValue) { minValue = tmpValue_5;}
      }
      
      if (TradePairs[u] == "CADJPY")
      {
         //Alert(maxValue);
      }
      
      minWindow = minValue - (maxValue - minValue) * tdiBias * 0.01 / 2;
      maxWindow = maxValue + (maxValue - minValue) * tdiBias * 0.01 / 2;
      resultValue = iCustom(TradePairs[u], tf_2, tdiIndicatorName, tdiBufferIndex, 0);
      if ((maxWindow - minWindow) > 0.0)
      {
         tmpValue = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         tmpValue = 0.01;
      }
      
      resultValue = iCustom(TradePairs[u], tf_2, tdiIndicatorName, tdiBufferIndex, 1);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_12 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_12 = 0.01;
      }
      resultValue = iCustom(TradePairs[u], tf_2, tdiIndicatorName, tdiBufferIndex, 2);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_22 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_22 = 0.01;
      }
      
      textName = objectPreamble + "Tdi2_Text_" + IntegerToString(u);
      panelName = objectPreamble + "PTdi2_Panel_" + IntegerToString(u);
      ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToString(tmpValue, 1));
      
      if (tmpValue >= tdiLevel)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
      }
      else if (tmpValue <= (100 - tdiLevel))
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      pairInfo[u].tdiValue_2 = tmpValue;
   }
}

void calculateTdi_3()
{
   double maxValue, minValue, resultValue;
   double tmpValue_1, tmpValue_2, tmpValue_3, tmpValue_4, tmpValue_5;
   double minWindow, maxWindow, tmpValue;
   string textName;
   string panelName;
   
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      maxValue = -10000.0;
      minValue = 10000.0;
      
      for ( int uu = 0; uu < tdiLookBackBars_tf3; uu++)
      {
         tmpValue_1 = iCustom(TradePairs[u], tf_3, tdiIndicatorName, 0, uu);
         tmpValue_2 = iCustom(TradePairs[u], tf_3, tdiIndicatorName, 2, uu);
         tmpValue_3 = iCustom(TradePairs[u], tf_3, tdiIndicatorName, 3, uu);
         tmpValue_4 = iCustom(TradePairs[u], tf_3, tdiIndicatorName, 1, uu);
         tmpValue_5 = iCustom(TradePairs[u], tf_3, tdiIndicatorName, 4, uu);
         
         if (tmpValue_1 > maxValue) { maxValue = tmpValue_1;}
         if (tmpValue_2 > maxValue) { maxValue = tmpValue_2;}
         if (tmpValue_3 > maxValue) { maxValue = tmpValue_3;}
         if (tmpValue_4 > maxValue) { maxValue = tmpValue_4;}
         if (tmpValue_5 > maxValue) { maxValue = tmpValue_5;}
         
         if (tmpValue_1 < minValue) { minValue = tmpValue_1;}
         if (tmpValue_2 < minValue) { minValue = tmpValue_2;}
         if (tmpValue_3 < minValue) { minValue = tmpValue_3;}
         if (tmpValue_4 < minValue) { minValue = tmpValue_4;}
         if (tmpValue_5 < minValue) { minValue = tmpValue_5;}
      }
      
      if (TradePairs[u] == "CADJPY")
      {
         //Alert(maxValue);
      }
      
      minWindow = minValue - (maxValue - minValue) * tdiBias * 0.01 / 2;
      maxWindow = maxValue + (maxValue - minValue) * tdiBias * 0.01 / 2;
      resultValue = iCustom(TradePairs[u], tf_3, tdiIndicatorName, tdiBufferIndex, 0);
      if ((maxWindow - minWindow) > 0.0)
      {
         tmpValue = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         tmpValue = 0.01;
      }
      
      resultValue = iCustom(TradePairs[u], tf_3, tdiIndicatorName, tdiBufferIndex, 1);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_13 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_13 = 0.01;
      }
      resultValue = iCustom(TradePairs[u], tf_3, tdiIndicatorName, tdiBufferIndex, 2);
      if ((maxWindow - minWindow) > 0.0)
      {
         pairInfo[u].tdiValue_23 = (resultValue - minWindow) / (maxWindow - minWindow) * 100.0;
      }
      else
      {
         pairInfo[u].tdiValue_23 = 0.01;
      }
      
      textName = objectPreamble + "Tdi3_Text_" + IntegerToString(u);
      panelName = objectPreamble + "PTdi3_Panel_" + IntegerToString(u);
      ObjectSetString(0, textName, OBJPROP_TEXT, DoubleToString(tmpValue, 1));
      
      if (tmpValue >= tdiLevel)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
      }
      else if (tmpValue <= (100 - tdiLevel))
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      pairInfo[u].tdiValue_3 = tmpValue;
   }
}

void displayKelt_1()
{
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PKelt1_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetKeltColumn_1, yAnchor + u * (rowHeight + rowSpacing), widthKelt_1, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Kelt1_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetKeltColumn_1 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void displayKelt_2()
{
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PKelt2_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetKeltColumn_2, yAnchor + u * (rowHeight + rowSpacing), widthKelt_2, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Kelt2_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetKeltColumn_2 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void displayKelt_3()
{
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "PKelt3_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetKeltColumn_3, yAnchor + u * (rowHeight + rowSpacing), widthKelt_1, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "Kelt3_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetKeltColumn_3 + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   }
}

void calculateKeltner_1()
{
   double ma, atr, KU_0, KL_0, KU_1, KL_1;
   string panelName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      ma = iMA(TradePairs[u], tf_1, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_1, keltnerPeriod, 1);
      KU_0 = ma + atr * atrMultiplier_1;
      KL_0 = ma - atr * atrMultiplier_1;
      pairInfo[u].keltnerValueUp_11 = KU_0;
      pairInfo[u].keltnerValueDown_11 = KL_0;
      
      ma = iMA(TradePairs[u], tf_1, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_1, keltnerPeriod, 1);
      KU_1 = ma + atr * atrMultiplier_2;
      KL_1 = ma - atr * atrMultiplier_2;
      pairInfo[u].keltnerValueUp_12 = KU_1;
      pairInfo[u].keltnerValueDown_12 = KL_1;
      
      panelName = objectPreamble + "PKelt1_Panel_" + IntegerToString(u);
      if (iHigh(TradePairs[u], tf_1, 0) > KU_1 )
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner upper level 1, TF1 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }  
      }
      else if (iHigh(TradePairs[u], tf_1, 0) > KU_0 &&  iHigh(TradePairs[u], tf_1, 0) < KU_1)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrPink);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner upper level 1, TF1 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }  
      }
      else if (iLow(TradePairs[u], tf_1, 0) < KL_1)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner lower level, TF1 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }
      }
      else if (iLow(TradePairs[u], tf_1, 0) > KL_1 && iLow(TradePairs[u], tf_1, 0) < KL_0)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrOlive);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner lower level, TF1 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      // check for resetting alert time
      if (pairInfo[u].alertDone)
      {
         if (LocalTime() > alertTime[u] + alertResetInMinutes * 60)
         {
            pairInfo[u].alertDone = false;
            alertTime[u] = 0;
         }
      }
   }
}

void calculateKeltner_2()
{
   double ma, atr, KU, KL;
   string panelName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      ma = iMA(TradePairs[u], tf_2, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_2, keltnerPeriod, 1);
      KU = ma + atr * atrMultiplier_1;
      KL = ma - atr * atrMultiplier_1;
      pairInfo[u].keltnerValueUp_21 = KU;
      pairInfo[u].keltnerValueDown_21 = KL;
      
      ma = iMA(TradePairs[u], tf_2, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_2, keltnerPeriod, 1);
      KU = ma + atr * atrMultiplier_2;
      KL = ma - atr * atrMultiplier_2;
      pairInfo[u].keltnerValueUp_22 = KU;
      pairInfo[u].keltnerValueDown_22 = KL;
      
      panelName = objectPreamble + "PKelt2_Panel_" + IntegerToString(u);
      if (iHigh(TradePairs[u], tf_2, 0) > KU)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner upper level, TF2 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }  
      }
      else if (iLow(TradePairs[u], tf_2, 0) < KL)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner lower level, TF2 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      // check for resetting alert time
      if (pairInfo[u].alertDone)
      {
         if (LocalTime() > alertTime[u] + alertResetInMinutes * 60)
         {
            pairInfo[u].alertDone = false;
            alertTime[u] = 0;
         }
      }
   }
}

void calculateKeltner_3()
{
   double ma, atr, KU, KL;
   string panelName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      ma = iMA(TradePairs[u], tf_3, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_3, keltnerPeriod, 1);
      KU = ma + atr * atrMultiplier_1;
      KL = ma - atr * atrMultiplier_1;
      pairInfo[u].keltnerValueUp_31 = KU;
      pairInfo[u].keltnerValueDown_31 = KL;
      
      ma = iMA(TradePairs[u], tf_3, keltnerPeriod, 0,  MODE_SMA, PRICE_CLOSE,  0);
      atr = iATR(TradePairs[u], tf_3, keltnerPeriod, 1);
      KU = ma + atr * atrMultiplier_2;
      KL = ma - atr * atrMultiplier_2;
      pairInfo[u].keltnerValueUp_32 = KU;
      pairInfo[u].keltnerValueDown_32 = KL;
      
      panelName = objectPreamble + "PKelt3_Panel_" + IntegerToString(u);
      if (iHigh(TradePairs[u], tf_3, 0) > KU)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrRed);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner upper level, TF3 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }  
      
      }
      else if (iLow(TradePairs[u], tf_3, 0) < KL)
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrGreen);
         if (alertsActive && !pairInfo[u].alertDone && !pairInfo[u].disableAlerts)
         {
            Alert("Keltner lower level, TF3 for pair: " + TradePairs[u]);
            pairInfo[u].alertDone = true;
            alertTime[u] = LocalTime();
         }
      }
      else
      {
         ObjectSetInteger(0, panelName, OBJPROP_BGCOLOR, clrBlack);
      }
      
      // check for resetting alert time
      if (pairInfo[u].alertDone)
      {
         if (LocalTime() > alertTime[u] + alertResetInMinutes * 60)
         {
            pairInfo[u].alertDone = false;
            alertTime[u] = 0;
         }
      }
   }
}

void displayTradeInfos()
{
   
   string panelName, textName;
   for ( int u = 0; u < ArraySize(TradePairs); u++)
   {
      panelName = objectPreamble + "tiBuyLots_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTradeInfoColumns, yAnchor + u * (rowHeight + rowSpacing), widthTradeInfoColumns, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "tiBuyLots_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTradeInfoColumns + textIndent, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   
      panelName = objectPreamble + "tiSellLots_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTradeInfoColumns + widthTradeInfoColumns + columnSpacing, yAnchor + u * (rowHeight + rowSpacing), widthTradeInfoColumns, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "tiSellLots_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTradeInfoColumns + textIndent + widthTradeInfoColumns + columnSpacing, yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   
      panelName = objectPreamble + "tiBuyMoney_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTradeInfoColumns + 2 * (widthTradeInfoColumns + columnSpacing), yAnchor + u * (rowHeight + rowSpacing), widthTradeInfoColumns, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "tiBuyMoney_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTradeInfoColumns + textIndent + 2 * ( widthTradeInfoColumns + columnSpacing), yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);
   
      panelName = objectPreamble + "tiSellMoney_Panel_" + IntegerToString(u);
      SetPanel(panelName, 0, xAnchor + offsetTradeInfoColumns + 3 * (widthTradeInfoColumns + columnSpacing), yAnchor + u * (rowHeight + rowSpacing), widthTradeInfoColumns, rowHeight,clrBlack, borderColor, 1);
      textName = objectPreamble + "tiSellMoney_Text_" + IntegerToString(u);
      SetText(textName,"", 0, xAnchor + offsetTradeInfoColumns + textIndent + 3 * ( widthTradeInfoColumns + columnSpacing), yAnchor + u * (rowHeight + rowSpacing) + textY_offset, clrWhiteSmoke, fontSize);

  
   }  

}


void calculateTradeInfos()
{

   totallots=0;
   totalprofit=0;
   totaltrades = 0;

   for(int i = 0;i < ArraySize(TradePairs); i++)
   {
      bpos[i]=0;
      spos[i]=0;       
      blots[i]=0;
      slots[i]=0;     
      bprofit[i]=0;
      sprofit[i]=0;
      tprofit[i]=0;
   } 
	for(int i = 0; i < OrdersTotal(); i++)
	{
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
         break;

      for(int j = 0; j < ArraySize(TradePairs); j++)
      {	  

         if((TradePairs[j] == OrderSymbol() || TradePairs[j] == ""))
         {
            TradePairs[j] = OrderSymbol();                       
           tprofit[j] = tprofit[j] + OrderProfit() + OrderSwap() + OrderCommission();
           if(OrderType()==0){ bprofit[j]+=OrderProfit()+OrderSwap()+OrderCommission(); } 
           if(OrderType()==1){ sprofit[j]+=OrderProfit()+OrderSwap()+OrderCommission(); } 
           if(OrderType()==0){ blots[j]+=OrderLots(); } 
           if(OrderType()==1){ slots[j]+=OrderLots(); }
           if(OrderType()==0){ bpos[j]+=+1; } 
           if(OrderType()==1){ spos[j]+=+1; } 
                                
            totallots=totallots+OrderLots();
            totaltrades++;
            totalprofit = totalprofit+OrderProfit()+OrderSwap()+OrderCommission();
            break;
	      }
	   }
   }
   
   PlotTrades();
}

void PlotTrades() 
{
   string textName;
   
   for (int i=0; i<ArraySize(TradePairs);i++) 
   {
     if(blots[i]>0){LotColor =Orange;}        
     if(blots[i]==0){LotColor =C'61,61,61';}
     if(slots[i]>0){LotColor1 =Orange;}        
     if(slots[i]==0){LotColor1 =C'61,61,61';}
     if(bpos[i]>0){OrdColor =DodgerBlue;}        
     if(bpos[i]==0){OrdColor =C'61,61,61';}
     if(spos[i]>0){OrdColor1 =DodgerBlue;}        
     if(spos[i]==0){OrdColor1 =C'61,61,61';}
     if(bprofit[i]>0){ProfitColor =BullColor;}
     if(bprofit[i]<0){ProfitColor =BearColor;}
     if(bprofit[i]==0){ProfitColor =C'61,61,61';}
     if(sprofit[i]>0){ProfitColor2 =BullColor;}
     if(sprofit[i]<0){ProfitColor2 =BearColor;}
     if(sprofit[i]==0){ProfitColor2 =C'61,61,61';}
     if(tprofit[i]>0){ProfitColor3 =BullColor;}
     if(tprofit[i]<0){ProfitColor3 =BearColor;}
     if(tprofit[i]==0){ProfitColor3 =C'61,61,61';}

     if(totalprofit>0){ProfitColor1 =BullColor;}
     if(totalprofit<0){ProfitColor1 =BearColor;}
     if(totalprofit==0){ProfitColor1 =clrWhite;}         

     textName = objectPreamble + "tiBuyLots_Text_" + IntegerToString(i);
     ObjectSetText(textName,DoubleToStr(blots[i],2),fontSize,NULL,LotColor);
     textName = objectPreamble + "tiSellLots_Text_" + IntegerToString(i);
     ObjectSetText(textName,DoubleToStr(slots[i],2),fontSize,NULL,LotColor1);
     textName = objectPreamble + "tiBuyMoney_Text_" + IntegerToString(i);
     ObjectSetText(textName,DoubleToStr(MathAbs(bprofit[i]),1),fontSize,NULL,ProfitColor);
     textName = objectPreamble + "tiSellMoney_Text_" + IntegerToString(i);
     ObjectSetText(textName,DoubleToStr(MathAbs(sprofit[i]),1),fontSize,NULL,ProfitColor2);
     
     
     //ObjectSetText("TtlProf"+IntegerToString(i),DoubleToStr(MathAbs(tprofit[i]),2),8,NULL,ProfitColor3);
     
     textName = objectPreamble + "tradeTotalsTextHeader";
     ObjectSetText(textName,"  " + DoubleToStr(MathAbs(totalprofit),2),fontSize+1,NULL,ProfitColor1);
   }
}